/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, delegateCombine, delegateRemove, markType } from "igniteui-angular-core";
import { IAnnotationLayerProxy_$type } from "./IAnnotationLayerProxy";
import { CrosshairLayer } from "./CrosshairLayer";
import { ValueLayer } from "./ValueLayer";
import { CalloutLayer } from "./CalloutLayer";
import { FinalValueLayer } from "./FinalValueLayer";
import { DataToolTipLayer } from "./DataToolTipLayer";
import { DoubleCollection } from "igniteui-angular-core";
/**
 * @hidden
 */
export let AnnotationLayerProxy = /*@__PURE__*/ (() => {
    class AnnotationLayerProxy extends Base {
        constructor() {
            super(...arguments);
            this._container = null;
        }
        get container() {
            return this._container;
        }
        set container(a) {
            this._container = a;
        }
        matchesType(a) {
            if (!a.es) {
                return false;
            }
            return true;
        }
        createCrosshairLayer() {
            let a = new CrosshairLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createValueLayer() {
            let a = new ValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createCalloutLayer() {
            let a = new CalloutLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        createFinalValueLayer() {
            let a = new FinalValueLayer();
            let b = this.container.getExternal(a, null, null);
            return a;
        }
        setCrosshairHorizontalLineVisibility(a, b) {
            a.acm = b;
        }
        setCrosshairVerticalLineVisibility(a, b) {
            a.acn = b;
        }
        setCrosshairHorizontalLineStroke(a, b) {
            a.aca = b;
        }
        setCrosshairVerticalLineStroke(a, b) {
            a.acb = b;
        }
        setCrosshairXAxisForeground(a, b) {
            a.ace = b;
        }
        setCrosshairYAxisForeground(a, b) {
            a.ach = b;
        }
        setCrosshairXAxisBackground(a, b) {
            a.acc = b;
        }
        setCrosshairYAxisBackground(a, b) {
            a.acf = b;
        }
        setCrosshairYAxisPrecision(a, b) {
            a.aaj = b;
        }
        setCrosshairXAxisPrecision(a, b) {
            a.aai = b;
        }
        setCrosshairOnAxesEnabled(a, b) {
            a.z1 = b;
        }
        setCrosshairUseInterpolation(a, b) {
            a.z3 = b;
        }
        setCrosshairThickness(a, b) {
            a.jp = b;
        }
        isCrosshairLayer(a) {
            return typeCast(CrosshairLayer.$, a) !== null;
        }
        setFinalValuePrecision(a, b) {
            a.z8 = b;
        }
        setFinalValueBackground(a, b) {
            a.aa2 = b;
        }
        setFinalValueForeground(a, b) {
            a.aa4 = b;
        }
        setContentMemberPath(a, b) {
            a.acv = b;
        }
        setCalloutsAllowedPositions(a, b) {
            a.z8 = b;
        }
        setLabelMemberPath(a, b) {
            a.ac9 = b;
        }
        setXMemberPath(a, b) {
            a.adp = b;
        }
        setYMemberPath(a, b) {
            a.ads = b;
        }
        setTargetSeries(a, b) {
            if (typeCast(CalloutLayer.$, a) !== null) {
                a.aad = b;
            }
            else {
                a.z1 = b;
            }
        }
        setCollisionChannel(a, b) {
            a.acs = b;
        }
        setIsAutoCalloutBehaviorEnabled(a, b) {
            a.aa3 = b;
        }
        setGreedyCollisionMode(a, b) {
            a.z3 = b ? 2 : 0;
        }
        setCollisionMode(a, b) {
            a.z3 = b;
        }
        setUseItemColorForFill(a, b) {
            a.aba = b;
        }
        setUseItemColorForOutline(a, b) {
            a.abb = b;
        }
        setCalloutStrokeThickness(a, b) {
            a.abx = b;
        }
        setUseAutoContrastingLabelColors(a, b) {
            a.aa8 = b;
        }
        setCalloutBackground(a, b) {
            a.afk = b;
        }
        setAutoCalloutLabelPrecision(a, b) {
            a.ab0 = b;
        }
        setCalloutLightColor(a, b) {
            a.afn = b;
        }
        setCalloutDarkColor(a, b) {
            a.afl = b;
        }
        setCalloutOutline(a, b) {
            a.afo = b;
        }
        setCalloutLeaderBrush(a, b) {
            a.afm = b;
        }
        setCalloutTextColor(a, b) {
            a.afp = b;
        }
        setShouldTruncateOnBoundaryCollisions(a, b) {
            a.aa7 = b;
        }
        setUseDedicatedLanes(a, b) {
            a.z1 = b ? 2 : 0;
        }
        isCalloutLayer(a) {
            if (typeCast(CalloutLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isDataToolTipLayer(a) {
            if (typeCast(DataToolTipLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        isFinalValueLayer(a) {
            if (typeCast(FinalValueLayer.$, a) !== null) {
                return true;
            }
            return false;
        }
        addCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
        }
        removeCalloutStyleUpdating(a, b) {
            let c = a;
            c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
        }
        addCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateCombine(c.calloutRenderStyleUpdating, b);
        }
        removeCalloutRenderStyleUpdating(a, b) {
            let c = a;
            c.calloutRenderStyleUpdating = delegateRemove(c.calloutRenderStyleUpdating, b);
        }
        setCalloutStyleUpdatingEventEnabled(a, b) {
            a.aa6 = b;
        }
        setUseValueForAutoCalloutLabels(a, b) {
            a.abd = b;
        }
        setCalloutRenderStyleUpdatingEventEnabled(a, b) {
            a.aa5 = b;
        }
        updateDataToolTipPropertyByName(a, b, c) {
            a.afi(b, c);
        }
        getIsAutoCalloutBehaviorEnabled(a) {
            return a.aa3;
        }
        setValueMode(a, b) {
            a.z3 = b;
        }
        setUseLegend(a, b) {
            a.xj = b;
        }
        setTitle(a, b) {
            a.title = b;
        }
        setLegendItemBadgeShape(a, b) {
            a.legendItemBadgeShape = b;
        }
        setValueAxisAnnotationEnabled(a, b) {
            a.z5 = b;
        }
        getValueMode(a) {
            return a.z3;
        }
        isValueLayer(a) {
            return typeCast(ValueLayer.$, a) !== null;
        }
        setBrush(a, b) {
            a.vd = b;
        }
        setDashArray(a, b) {
            let c = new DoubleCollection();
            for (let d = 0; d < b.length; d++) {
                c.add(b[d]);
            }
            a.v0 = c;
        }
    }
    AnnotationLayerProxy.$t = markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);
    return AnnotationLayerProxy;
})();
